#!/bin/sh

#(c) www.okchat.com
#author Georgi Bochukov
#support@okchat.com

########################################
#
#Change only this please 
#

JAVA_HOME="/usr/lib/j2sdk1.3.1"

########################################

MNAME=`uname -n`
OKCHAT_HOME=`pwd`

LOG_DIR=$OKCHAT_HOME
USERNAME="okchat"
LOG_FILE_LINK=$LOG_DIR/current.log

PID_FILE=$OKCHAT_HOME/okchat.pid
LOCK_FILE=$OKCHAT_HOME/OKCHAT.LCK
ALIVE_FILE=$OKCHAT_HOME/server.alive

RESTART_DELAY=30
CHECK_DELAY=10

case "$1" in
'stop')
        echo "Explicitly stop called"; 	
 	cat $PID_FILE;
	MYPID=`cat $PID_FILE`;
	echo "MYPID : $MYPID";
	
 	for PIDS in `ps -axwww | grep java | grep -v grep | awk '{ print $1 }' `;
 	do	
		echo "Found PID $PIDS"
		if [ $PIDS == $MYPID ] ; then	
			kill -9 ${MYPID}
			echo "KILL PROCESS ${MYPID}"
		fi
 	done 
	rm -f $PID_FILE 2>/dev/null;
 	echo "done"
;;


'status')
	ERROR=0;

 	echo "checking for running okchatstart.sh";
 	if [ -f $PID_FILE ];
 	then
		ERROR=0;
	else
  		echo "Restarting okchatstart.sh in background";
  		$OKCHAT_HOME/okchatstart.sh start CLEAN &
		exit 1;
 	fi

 	echo "check for running okChat"
	if (test -z "`ps -axwww | grep java | grep -v grep`");
 	then
  		echo "No JVMs found";
  		ERROR=1;
 	fi

	echo ${ERROR}
	
 	if [ $ERROR == 0 ];
 	then
  		echo "okChat OK";
  		exit 1;
	else
		echo "Error occured - killing all JVMs";
  		$0 stop
		exit 1;
 	fi

;;

'start')
 
	# test if exists PID
 	if (test -f "$PID_FILE" )
 	then
  		if [ $2 = "CLEAN" ];
  		then
   			rm -rf $PID_FILE;
  		else
			echo "Found PID file $PID_FILE - check okChat"
			exit 1
		fi
 	fi


 	#while (true);
 	#do
		echo 
  		echo "==============================="
		echo "Restarted at: `date`"
		echo
  
		LOG_FILE="start_log.`date +"%H%M_%d%m"`"

		# delay startup
  		while (test -e "$LOCK_FILE");
  		do
		   	#echo "Lockfile $LOCK_FILE exists - suspending for $CHECK_DELAY seconds";
   			sleep $CHECK_DELAY;
  		done

  		# compressing logs
  		echo "Removing logfile link $LOG_FILE_LINK...";
  		rm $LOG_FILE_LINK 2>&1 >/dev/null ;
  		echo "done";

  		echo "Starting jvm..."
		cd `dirname $0`

		unset CLASSPATH
		for JAR in `find ./lib/jars -name "*.jar"`; do
			CLASSPATH=$JAR:$CLASSPATH
		done
        
		CLASSPATH="$CLASSPATH:./lib/classes"

		PATH=/bin:/usr/bin:${JAVA_HOME}/bin

		export PATH CLASSPATH JAVA_HOME

		java -cp "$CLASSPATH" bochi.okchat.server.ChatServer  2>&1 > $LOG_FILE &
		
		echo "setting up link $LOG_FILE_LINK --> $LOG_FILE"
		ln -s $LOG_FILE $LOG_FILE_LINK

  		echo "Waiting for PID $!";
  		echo $! > $PID_FILE ;
  		
 	
;;

'restart')
	$0 stop
	$0 start
;;

'log')
       tail -f $LOG_FILE_LINK
        ;;

'startlog')
       tail -f $OKCHAT_HOME/nohup.out
        ;;

*)
 echo "usage: $0 {stop|start|restart|log}"
;;

esac
exit 0
